#ifndef _HITBOX_CPP_
#define _HITBOX_CPP_

#include "hitbox.h"

#include "allegro.h"
#include "gameConstants.h"

#include <vector>
using namespace std;

hitbox :: hitbox ()
{
  unitType = unitNull;

  damageDealt = 0;
  knockbackDrift = 0;
  knockbackType = knockbackRelative;

  knockbackAbsAngle = itofix (0);
  knockbackAbsMag = itofix (0);

  collideAction = new vector <int> (numUnitTypes, collideIgnore);
  stunCollideAction = new vector <int> (numUnitTypes, collideIgnore);

  statusAilmentDmg = new vector <int> (numStatusAilment, 0);
}

hitbox :: hitbox (int defaultCollideAction)
{
  hitbox ();

  for (int i = 0; i < numUnitTypes; i ++)
    {
      collideAction -> at (i) = defaultCollideAction;
      stunCollideAction -> at (i) = defaultCollideAction;
    }
}

int hitbox :: checkCollide (int unitType, bool unitStunned)
{
  //returns the type of collision between THIS unit and unitType.
  //or: If THIS (object) hits a unit of type unitType, what does unitType do to me?

  if (unitType < 0 || unitType > numUnitTypes)
    return collideKnockbackOnly;

  if (!unitStunned)
      return collideAction -> at (unitType);
  else
      return stunCollideAction -> at (unitType);
  return collideKnockbackOnly;
}

void hitbox :: addCollide (int unitType, int cA, bool stunned)
{
  if (!stunned)
    {
      collideAction -> at (unitType) = cA;
    }
  else
    {
      stunCollideAction -> at (unitType) = cA;
    }
}

hitbox :: ~hitbox ()
{
}
#endif
