#ifndef _HOMINGUNIT_CPP
#define _HOMINGUNIT_CPP_

#include "unit.h"
#include "unitList.h"
#include "homingUnit.h"
#include "hitbox.h"
#include "allegro.h"
#include "dataObj.h"
#include "inputObj.h"
#include "cursor.h"
#include "gameConstants.h"
#include "tasmMath.h"
#include <math.h>

#include <vector>
using namespace std;

homingUnit :: homingUnit ()
{
}

void homingUnit :: init (int param1, int param2, int param3)
{
  switch (unitType)
    {
    case (unitHomer):
      unitCursorAngle = itofix (rand () % 256);
      aimTimeMax = 60;
      rushTimeMax = 60;
      homingTimer = 0;
      rushing = false;

      statusAilment -> at (statusAilmentInvic) = 5;

      hitPoints = 1000;
      maxHP = 1000;
      moveSpeed = itofix (2);

      if (param3 == 1)
	{
	  //create uber homer!
	  hitPoints = 5000;
	  maxHP = 5000;
	  moveSpeed = ftofix (10);
	  drawScale = ftofix (2.0);
	  hb -> damageDealt = 750;
	  immuneToAilments = true;
	}

      wantsToTaunt = true;
      
      aimTimeMax = param1;
      rushTimeMax = param2;

      homingTimer = aimTimeMax;
      setAffiliation (affiliationEnemy);
      break;
    case (unitBadmojo):
      unitCursorAngle = itofix (0);
      hitPoints = 1;
      maxHP = 1;
      timeToLive = 120;
      moveSpeed = itofix (5);
      setAffiliation (affiliationEnemy);
      diesWhenHitsAnything = true;
      hpToGivePlayer = 50;
      break;
    default:
      break;
    }
}

void homingUnit :: processInput (dataObj * dO, unitList * units)
{
  //it should aim and chase the player.
  //first, get the player.

  fixed unitDist = itofix (0);
  vector <unit *> * gub = units -> search (units -> getUnits (), searchByAffiliation, affiliationPlayer);

  //if OK...

  if (currentActivity == charStatusDead || currentActivity == charStatusStun)
    return;

  switch (unitType)
    {
    case (unitHomer):
      if (!rushing)
	{
	  moveMag = 0;
	  if (gub -> size () > 0)
	    unitCursorAngle = calcAngle (posX, posY, gub -> at (0) -> getPosX (), gub -> at (0) -> getPosY (), moveAngle);
    }
      
      if (rushing)
	{
	  moveMag = 4;
	}
      
      homingTimer--;
      
      if (homingTimer <= 0 && rushing)
	{
	  homingTimer = aimTimeMax;
	  rushing = !rushing;
	}
      
      if (homingTimer <= 0 && !rushing)
	{
	  homingTimer = rushTimeMax;
	  rushing = !rushing;
	}
      moveAngle = unitCursorAngle;
      drawAngle = unitCursorAngle;
      break;
    case (unitBadmojo):
    
      moveMag = 4;

      if (gub -> size () > 0)
	{
	  unitCursorAngle = calcAngle (posX, posY, gub -> at (0) -> getPosX (), gub -> at (0) -> getPosY (), moveAngle);

	  unitDist = calcDist (posX, posY, gub -> at (0) -> getPosX (), gub -> at (0) -> getPosY ());

	  if (unitDist < itofix (150))
	    moveMag = 2;
	}

      moveAngle = unitCursorAngle;
      drawAngle = unitCursorAngle;
      break;
    }
}

homingUnit :: ~homingUnit ()
{

}
#endif
