#ifndef _INPUTOBJ_H_
#define _INPUTOBJ_H_

#include <stdio.h>
#include <math.h>

#include "allegro.h"
#include "cursor.h"

#include <vector>
using namespace std;

class inputObj
{
public:
  inputObj ();
  ~inputObj ();

  //processes the input
  void processInput(int, int, bool);

  //accessors and modifiers
  vector<int>* getKeyMap ();
  int setKeyMap (vector<int>* );
  vector<bool>* getKeyWasHit ();
  int setKeyWasHit (vector<bool>* );
  vector<bool>* getKeyWasClicked ();
  int setKeyWasClicked (vector<bool>* );

  vector<bool>* getMouseWasHit ();
  int setMouseWasHit (vector<bool>* );
  vector<bool>* getMouseWasClicked ();
  int setMouseWasClicked (vector<bool>* );

  int getInputWait ();
  void setInputWait (int);
  void getMouseUsedLast (bool &);
  void setMouseUsedLast (bool);
  void getKeyWasHitThisFrame (bool &);
  void setKeyWasHitThisFrame (bool);

  cursor * getCursor ();
  int setCursor (cursor *);

  void setControlThreshold (int);
  int getControlThreshold ();

protected:
  //   general input settings
  vector<int> * keyMap;
  vector<bool> * keyWasHit;
  vector<bool> * keyWasClicked;

  vector<bool> * mouseWasHit;
  vector<bool> * mouseWasClicked;

  int inputWait;
  bool mouseUsedLast;
  bool keyWasHitThisFrame;

  int controlThreshold;

  //   cursor settings
  cursor * cur;

};

#endif
