#ifndef _LOADER_CPP_
#define _LOADER_CPP_

#include "unitCreate.h"
#include "dumbUnit.h"
#include "homingUnit.h"
#include "playerUnit.h"
#include "poleonUnit.h"
#include "allegro.h"
#include "unit.h"
#include "unitCreate.h"
#include "unitGraphics.h"
#include "unitList.h"
#include "hitbox.h"
#include "dataObj.h"
#include "allegro.h"
#include "tasmData.h"

#include "loader.h"

#include "gameConstants.h"

#include <vector>
using namespace std;

loader :: loader ()
{

}

void loader :: init (unitList * units, DATAFILE * picData)
{
  for (int i = 1; i < numUnitTypes; i++) //don't load unitNull!!!
    {
      createUnit (i, units, picData);
    }
}

void loader :: createUnit (int unitType, unitList * units, DATAFILE * picData)
{
  unitGraphics * uG = new unitGraphics ();
  hitbox * hb = new hitbox ();

  //this creates a unit, for the very first time.
  switch (unitType)
    {
    case (unitPoleon):
      uG = new unitGraphics ();
      uG -> insertPic ((BITMAP *)picData[poleonRest].dat, charAnimIdle);
      uG -> insertPic ((BITMAP *)picData[poleonRun].dat, charAnimRun);
      uG -> insertPic ((BITMAP *)picData[poleonAtt1].dat, charAnimAttack1);
      uG -> insertPic ((BITMAP *)picData[poleonAtt2].dat, charAnimAttack1);
      uG -> insertPic ((BITMAP *)picData[poleonAtt3].dat, charAnimAttack2);
      uG -> insertPic ((BITMAP *)picData[poleonAtt4].dat, charAnimAttack2);
      uG -> insertPic ((BITMAP *)picData[poleonAtt5].dat, charAnimAttack2);
      uG -> insertPic ((BITMAP *)picData[poleonAtt6].dat, charAnimAttack2);
      uG -> insertPic ((BITMAP *)picData[poleonAtt3].dat, charAnimAttack2);
      uG -> insertPic ((BITMAP *)picData[poleonInvic].dat, charAnimDefense);
      uG -> insertPic ((BITMAP *)picData[poleonDead].dat, charAnimDead);
      uG -> insertPic ((BITMAP *)picData[poleonStun].dat, charAnimStun);
      uG -> unitType = unitPoleon;
      units -> addGraphics (uG);

      hb = new hitbox ();
      hb -> unitType = unitPoleon;
      hb -> damageDealt = 0;
      hb -> addCollide (unitHomer, collideBoth, false);
      hb -> addCollide (unitBadmojo, collideBoth, false);
      hb -> addCollide (unitJuiceBox, collideBoth, false);
      hb -> addCollide (unitJuiceBox, collideBoth, true);
      units -> addHitbox (hb);
      break;
    case (unitHomer):
      uG = new unitGraphics ();
      uG -> insertPic ((BITMAP *)picData[homing].dat, charAnimIdle);
      uG -> insertPic ((BITMAP *)picData[homing].dat, charAnimRun);
      uG -> insertPic ((BITMAP *)picData[homingDead].dat, charAnimDead);
      uG -> insertPic ((BITMAP *)picData[homingStun1].dat, charAnimStun);
      uG -> insertPic ((BITMAP *)picData[homingStun2].dat, charAnimStun);
      uG -> insertPic ((BITMAP *)picData[homingStun3].dat, charAnimStun);
      uG -> insertPic ((BITMAP *)picData[homingStun4].dat, charAnimStun);
      uG -> insertPic ((BITMAP *)picData[homingIntro1].dat, charAnimTaunt);
      uG -> insertPic ((BITMAP *)picData[homingIntro2].dat, charAnimTaunt);
      uG -> insertPic ((BITMAP *)picData[homingIntro3].dat, charAnimTaunt);
      uG -> insertPic ((BITMAP *)picData[homing].dat, charAnimTaunt);
      uG -> unitType = unitHomer;
      units -> addGraphics (uG);

      hb = new hitbox ();
      hb -> damageDealt = 400;
      hb -> statusAilmentDmg -> at (statusAilmentStun) = 5;
      hb -> unitType = unitHomer;
      hb -> knockbackDrift = 0;
      hb -> statusAilmentDmg -> at (statusAilmentLessDamage) = 30;
      hb -> addCollide (unitPoleon, collideBoth, false);
      hb -> addCollide (unitPoleonShot, collideBoth, false);
      hb -> addCollide (unitPoleonCircle, collideBoth, false);
      hb -> addCollide (unitPolosion, collideBoth, false);
      hb -> addCollide (unitJuiceBox, collideKnockbackOnly, false);
      hb -> addCollide (unitHomer, collideKnockbackOnly, false);

      hb -> addCollide (unitBadmojo, collideBoth, true);
      hb -> addCollide (unitHomer, collideBoth, true);
      units -> addHitbox (hb);
      break;
    case (unitPoleonShot):
      uG = new unitGraphics ();
      uG -> insertPic ((BITMAP *)picData[shot01].dat, charAnimIdle);
      uG -> insertPic ((BITMAP *)picData[shot01].dat, charAnimRun);
      uG -> insertPic ((BITMAP *)picData[shot01].dat, charAnimDead);
      uG -> unitType = unitPoleonShot;
      units -> addGraphics (uG);
  
      hb = new hitbox ();
      hb -> unitType = unitPoleonShot;
      hb -> damageDealt = 100;
      hb -> knockbackDrift = 5;
      hb -> knockbackType = knockbackAbsolute;
      hb -> knockbackAbsAngle = itofix (0);
      hb -> knockbackAbsMag = itofix (10);
      hb -> statusAilmentDmg -> at (statusAilmentStun) = 50;
      hb -> addCollide (unitHomer, collideBoth, false);
      hb -> addCollide (unitHomer, collideBoth, true);
      units -> addHitbox (hb);
      break;
    case (unitPoleonCircle):
      uG = new unitGraphics ();
      uG -> insertPic ((BITMAP *)picData[longArmsSmall].dat, charAnimIdle);
      uG -> insertPic ((BITMAP *)picData[longArmsSmall].dat, charAnimRun);
      uG -> insertPic ((BITMAP *)picData[longArmsSmall].dat, charAnimDead);
      uG -> insertPic ((BITMAP *)picData[longArmsSmall].dat, charAnimDead);
      uG -> insertPic ((BITMAP *)picData[longArmsSmall].dat, charAnimDead);
      uG -> insertPic ((BITMAP *)picData[longArmsSmall2].dat, charAnimDead);
      uG -> insertPic ((BITMAP *)picData[longArmsSmall2].dat, charAnimDead);
      uG -> insertPic ((BITMAP *)picData[longArmsSmall2].dat, charAnimDead);
      uG -> insertPic ((BITMAP *)picData[longArmsSmall3].dat, charAnimDead);
      uG -> insertPic ((BITMAP *)picData[longArmsSmall3].dat, charAnimDead);
      uG -> insertPic ((BITMAP *)picData[longArmsSmall3].dat, charAnimDead);
      uG -> unitType = unitPoleonCircle;
      units -> addGraphics (uG);
  
      hb = new hitbox ();
      hb -> unitType = unitPoleonCircle;
      hb -> damageDealt = 0;
      hb -> knockbackDrift = 10;
      hb -> knockbackType = knockbackAbsolute;
      hb -> knockbackAbsAngle = itofix (0);
      hb -> knockbackAbsMag = itofix (20);
      hb -> statusAilmentDmg -> at (statusAilmentStun) = 5;
      hb -> addCollide (unitHomer, collideBoth, false);
      hb -> addCollide (unitHomer, collideBoth, true);
      units -> addHitbox (hb);
      break;
    case (unitPolosion):
      uG = new unitGraphics ();
      uG -> insertPic ((BITMAP *)picData[polosion].dat, charAnimIdle);
      uG -> insertPic ((BITMAP *)picData[polosion].dat, charAnimRun);
      uG -> insertPic ((BITMAP *)picData[polosion].dat, charAnimDead);
      uG -> unitType = unitPolosion;
      units -> addGraphics (uG);
  
      hb = new hitbox ();
      hb -> unitType = unitPolosion;
      hb -> damageDealt = 500;
      hb -> knockbackDrift = 5;
      hb -> statusAilmentDmg -> at (statusAilmentStun) = 5;
      hb -> addCollide (unitHomer, collideBoth, false);
      hb -> addCollide (unitHomer, collideBoth, true);
      hb -> addCollide (unitBadmojo, collideBoth, false);
      hb -> addCollide (unitBadmojo, collideBoth, true);
      units -> addHitbox (hb);
      break;
    case (unitBadmojo):
      uG = new unitGraphics ();
      uG -> insertPic ((BITMAP *)picData[badmojoRest].dat, charAnimIdle);
      uG -> insertPic ((BITMAP *)picData[badMojoRun1].dat, charAnimRun);
      uG -> insertPic ((BITMAP *)picData[badMojoRun2].dat, charAnimRun);
      uG -> insertPic ((BITMAP *)picData[badMojoRun3].dat, charAnimRun);
      uG -> insertPic ((BITMAP *)picData[badMojoDead1].dat, charAnimDead);
      uG -> insertPic ((BITMAP *)picData[badMojoDead2].dat, charAnimDead);
      uG -> insertPic ((BITMAP *)picData[badMojoDead3].dat, charAnimDead);
      uG -> insertPic ((BITMAP *)picData[badmojoRest].dat, charAnimStun);
      uG -> insertPic ((BITMAP *)picData[badmojoRest].dat, charAnimTaunt);
      uG -> unitType = unitBadmojo;
      units -> addGraphics (uG);

      hb = new hitbox ();
      hb -> damageDealt = 0;
      hb -> statusAilmentDmg -> at (statusAilmentStun) = 0;
      hb -> statusAilmentDmg -> at (statusAilmentNoJuice) = 30;
      hb -> statusAilmentDmg -> at (statusAilmentLessDamage) = 60;
      hb -> statusAilmentDmg -> at (statusAilmentSpeedSlow) = 120;
      hb -> unitType = unitBadmojo;
      hb -> knockbackDrift = 0;
      hb -> addCollide (unitPoleon, collideBoth, false);
      hb -> addCollide (unitPoleon, collideBoth, true);
      hb -> addCollide (unitPolosion, collideDamageOnly, false);
      hb -> addCollide (unitPolosion, collideDamageOnly, true);
      hb -> addCollide (unitJuiceBox, collideKnockbackOnly, false);
      units -> addHitbox (hb);
      break;
    case (unitJuiceBox):
      uG = new unitGraphics ();
      uG -> insertPic ((BITMAP *)picData[juiceBox].dat, charAnimIdle);
      uG -> insertPic ((BITMAP *)picData[juiceBox].dat, charAnimRun);
      uG -> insertPic ((BITMAP *)picData[juiceBox].dat, charAnimRun);
      uG -> insertPic ((BITMAP *)picData[juiceBox].dat, charAnimDead);
      uG -> insertPic ((BITMAP *)picData[juiceBox].dat, charAnimStun);
      uG -> insertPic ((BITMAP *)picData[juiceBox].dat, charAnimTaunt);
      uG -> unitType = unitJuiceBox;
      units -> addGraphics (uG);

      hb = new hitbox ();
      hb -> damageDealt = -100;
      hb -> statusAilmentDmg -> at (statusAilmentInvic) = 30;
      hb -> statusAilmentDmg -> at (statusAilmentMoreJuice) = 60;
      hb -> statusAilmentDmg -> at (statusAilmentSpeedBoost) = 30;
      hb -> unitType = unitJuiceBox;
      hb -> knockbackDrift = 0;
      hb -> addCollide (unitPoleon, collideBoth, false);
      hb -> addCollide (unitHomer, collideKnockbackOnly, false);
      units -> addHitbox (hb);
      break;
    case (unitPlayerAim):
      uG = new unitGraphics ();
      uG -> insertPic ((BITMAP *)picData[playerAim].dat, charAnimIdle);
      uG -> insertPic ((BITMAP *)picData[playerAim].dat, charAnimRun);
      uG -> insertPic ((BITMAP *)picData[playerAim].dat, charAnimDead);
      uG -> unitType = unitPlayerAim;
      units -> addGraphics (uG);
  
      hb = new hitbox ();
      hb -> unitType = unitPlayerAim;
      units -> addHitbox (hb);
      break;
    default:
      break;
    }
}

void loader :: loadUnit (int unitType, unit * & un)
{
  //this adds a unit to the unitList.
  switch (unitType)
    {
    case (unitPlayer):
      un = new playerUnit ();
      break;
    case (unitPoleon):
      un = new poleonUnit ();
      break;
    case (unitHomer):
      un = new homingUnit ();
      break;
    case (unitPoleonShot):
      un = new dumbUnit ();
      un -> setDiesWhenHitsWall (true);
      un -> setDeathTimeRemoval (0);
      break;
    case (unitPoleonCircle):
      un = new dumbUnit ();
      un -> setDeathTimeRemoval (9);
      un -> setImmuneToAilments (true);
      break;
    case (unitPolosion):
      un = new dumbUnit ();
      un -> setDrawScale (0);
      un -> setDeathTimeRemoval (10);
      un -> setIgnoreWall (true);
      un -> setKnockbackMul (0);
      un -> setImmuneToAilments (true);
      break;
    case (unitBadmojo):
      un = new homingUnit ();
      un -> setDeathTimeRemoval (3);
      break;
    case (unitJuiceBox):
      un = new dumbUnit ();
      un -> setDeathTimeRemoval (1);
      break;
    case (unitPlayerAim):
      un = new dumbUnit ();
      break;
    default: //you forgot to define the unit...
      return;
      break;
    }
}

void loader :: loadRound (int rnd, int & nextRound, unitList * units, BITMAP * & introPic, dataObj * dO, DATAFILE * picData, bool gotoNextRound)
{
  //lookup stage. Figure out which units need to be loaded.

  unitCreate * uC = NULL;
  int pendingNextRound = -1;
  int nextRoundPick = rnd;

  //when loading each stage:
  //1) Load the size of the arena.
  //2) Load the background.
  //3) Tell the graphics to adjust to the new arena with 'dO -> getVideoSettings () -> setObjectPositions (dO -> getArena () -> getArenaSizeX (), dO -> getArena () -> getArenaSizeY ());'
  //4) Pick the nextRound (set with pendingNextRound)
  //5) clear the unitList with 'units -> clearAll ()'
  //6) Add units:
  //   -create a new unitCreate object
  //   -change its parameters
  //   -add it to the unit list with 'units -> addUnitCreate (uC)'
  //Add at least a playerUnit.

  if (gotoNextRound)
    nextRoundPick = nextRound;
  else
    nextRoundPick = rnd;

  switch (nextRoundPick) //lookup round number later
    {
    case (0):
      dO -> getArena () -> setArenaSize (300, 300);
      dO -> getArena () -> setArenaPic ((BITMAP *)picData[arenaDirt].dat);
      pendingNextRound = 1;
      introPic = (BITMAP *)picData[introRound00].dat;

      dO -> getVideoSettings () -> setObjectPositions (dO -> getArena () -> getArenaSizeX (), dO -> getArena () -> getArenaSizeY ());

      units -> clearAll ();

      uC = new unitCreate ();
      uC -> unitType = unitPoleon;
      uC -> posX = itofix (dO -> getArena () -> getArenaSizeX ()/2);
      uC -> posY = itofix (dO -> getArena () -> getArenaSizeY ()/2);
      uC -> faceAngle = 0;
      uC -> timeToCreate = 0;
      units -> addCreate (uC);

      for (int i = 0; i < 10; i++)
	{
	  uC = new unitCreate ();
	  uC -> unitType = unitHomer;

	  randomlyPlaceUnit (dO -> getArena (), uC -> posX, uC -> posY);

	  uC -> faceAngle = 0;
	  uC -> timeToCreate = 20 * i;
	  uC -> param1 = 15;
	  uC -> param2 = 60;
	  units -> addCreate (uC);
	}

      for (int i = 0; i < 2; i++)
	{
	  uC = new unitCreate ();
	  uC -> unitType = unitJuiceBox;

	  randomlyPlaceUnit (dO -> getArena (), uC -> posX, uC -> posY);

	  uC -> faceAngle = 0;
	  uC -> timeToCreate = 100 * i + 100;
	  units -> addCreate (uC);
	}
      break;
    case (1):
      dO -> getArena () -> setArenaSize (600, 300);
      dO -> getArena () -> setArenaPic ((BITMAP *)picData[arenaGrass].dat);
      pendingNextRound = 2;
      introPic = (BITMAP *)picData[introRound01].dat;

      dO -> getVideoSettings () -> setObjectPositions (dO -> getArena () -> getArenaSizeX (), dO -> getArena () -> getArenaSizeY ());

      units -> clearAll ();

      uC = new unitCreate ();
      uC -> unitType = unitPoleon;
      uC -> posX = itofix (dO -> getArena () -> getArenaSizeX ()/2);
      uC -> posY = itofix (dO -> getArena () -> getArenaSizeY ()/2);
      uC -> faceAngle = 0;
      uC -> timeToCreate = 0;
      units -> addCreate (uC);

      for (int i = 0; i < 20; i++)
	{
	  uC = new unitCreate ();
	  uC -> unitType = unitHomer;
	  
	  randomlyPlaceUnit (dO -> getArena (), uC -> posX, uC -> posY);
	  
	  uC -> faceAngle = 0;
	  uC -> timeToCreate = 15 * i;
	  uC -> param1 = 15;
	  uC -> param2 = 60;
	  units -> addCreate (uC);
	}

      for (int i = 0; i < 6; i++)
	{
	  uC = new unitCreate ();
	  uC -> unitType = unitBadmojo;
	  randomlyPlaceUnit (dO -> getArena (), uC -> posX, uC -> posY);
	  uC -> timeToCreate = (i * 60) + 60;
	  units -> addCreate (uC);
	}
      break;
    case (2):
      dO -> getArena () -> setArenaSize (500, 400);
      dO -> getArena () -> setArenaPic ((BITMAP *)picData[arenaSand].dat);
      pendingNextRound = -1;
      introPic = (BITMAP *)picData[introRound02].dat;

      dO -> getVideoSettings () -> setObjectPositions (dO -> getArena () -> getArenaSizeX (), dO -> getArena () -> getArenaSizeY ());

      units -> clearAll ();

      uC = new unitCreate ();
      uC -> unitType = unitPoleon;
      uC -> posX = itofix (dO -> getArena () -> getArenaSizeX ()/2);
      uC -> posY = itofix (dO -> getArena () -> getArenaSizeY ()/2);
      uC -> faceAngle = 0;
      uC -> timeToCreate = 0;
      units -> addCreate (uC);

      for (int i = 0; i < 4; i++)
	{
	  uC = new unitCreate ();
	  uC -> unitType = unitBadmojo;
	  randomlyPlaceUnit (dO -> getArena (), uC -> posX, uC -> posY);
	  uC -> timeToCreate = 150 * i;
	  units -> addCreate (uC);
	}

      for (int i = 0; i < 5; i++)
	{
	  uC = new unitCreate ();
	  uC -> unitType = unitBadmojo;
	  randomlyPlaceUnit (dO -> getArena (), uC -> posX, uC -> posY);
	  uC -> timeToCreate = 600;
	  units -> addCreate (uC);
	}

      for (int i = 0; i < 50; i++)
	{
	  uC = new unitCreate ();
	  uC -> unitType = unitHomer;

	  randomlyPlaceUnit (dO -> getArena (), uC -> posX, uC -> posY);

	  uC -> faceAngle = 0;
	  uC -> timeToCreate = 60 * ((i + 5)/5);
	  uC -> param1 = 15;
	  uC -> param2 = 60;
	  units -> addCreate (uC);
	}

      uC = new unitCreate ();
      uC -> unitType = unitHomer;
      randomlyPlaceUnit (dO -> getArena (), uC -> posX, uC -> posY);
      uC -> faceAngle = 0;
      uC -> timeToCreate = 700;
      uC -> param1 = 5;
      uC -> param2 = 15;
      uC -> param3 = 1;
      units -> addCreate (uC);

      for (int i = 0; i < 3; i++)
	{
	  uC = new unitCreate ();
	  uC -> unitType = unitJuiceBox;

	  randomlyPlaceUnit (dO -> getArena (), uC -> posX, uC -> posY);

	  uC -> faceAngle = 0;
	  uC -> timeToCreate = 200 * i + 100;
	  units -> addCreate (uC);
	}
      break;
    case (3):
      dO -> getArena () -> setArenaSize (300, 300);
      dO -> getArena () -> setArenaPic ((BITMAP *)picData[arenaDirt].dat);
      pendingNextRound = 3;
      introPic = (BITMAP *)picData[introRound00].dat;

      dO -> getVideoSettings () -> setObjectPositions (dO -> getArena () -> getArenaSizeX (), dO -> getArena () -> getArenaSizeY ());

      units -> clearAll ();

      uC = new unitCreate ();
      uC -> unitType = unitPoleon;
      uC -> posX = itofix (dO -> getArena () -> getArenaSizeX ()/2);
      uC -> posY = itofix (dO -> getArena () -> getArenaSizeY ()/2);
      uC -> faceAngle = 0;
      uC -> timeToCreate = 0;
      units -> addCreate (uC);

      for (int i = 0; i < 1; i++)
	{
	  uC = new unitCreate ();
	  uC -> unitType = unitHomer;

	  randomlyPlaceUnit (dO -> getArena (), uC -> posX, uC -> posY);

	  uC -> faceAngle = 0;
	  uC -> timeToCreate = 2000;
	  uC -> param1 = 300;
	  uC -> param2 = 60;
	  units -> addCreate (uC);
	}
      break;
    default:
      //This is the 'end of campaign' round. You've won if you got this far.

      dO -> getArena () -> setArenaSize (100, 100);
      dO -> getArena () -> setArenaPic ((BITMAP *)picData[arenaSand].dat);
      pendingNextRound = 0;
      introPic = (BITMAP *)picData[introYouWin].dat;

      dO -> getVideoSettings () -> setObjectPositions (dO -> getArena () -> getArenaSizeX (), dO -> getArena () -> getArenaSizeY ());

      units -> clearAll ();

      uC = new unitCreate ();
      uC -> unitType = unitPoleon;
      uC -> posX = itofix (dO -> getArena () -> getArenaSizeX ()/2);
      uC -> posY = itofix (dO -> getArena () -> getArenaSizeY ()/2);
      uC -> faceAngle = 0;
      uC -> timeToCreate = 0;
      units -> addCreate (uC);
      break;
    }

  if (gotoNextRound)
    {
      nextRound = pendingNextRound;      
    }
}

int loader :: getAffiliationByUnit (int unitType)
{
  switch (unitType)
    {
    case (unitPlayer):
      return affiliationPlayer;
      break;
    case (unitHomer):
      return affiliationEnemy;
      break;
    default:
      return affiliationNeutral;
      break;
    }
  return affiliationNeutral;
}

void loader :: randomlyPlaceUnit (arena * aren, fixed & posX, fixed & posY)
{
  int arenaX, arenaY;
  int temp = 0;

  arenaX = aren -> getArenaSizeX ();
  arenaY = aren -> getArenaSizeY ();

  temp = rand () % (arenaX * 2 + arenaY * 2);
  if (temp < arenaX)
    {
      posX = itofix (temp);
      posY = itofix (0);
    }
  else if (temp < arenaX + arenaY)
    {
      posX = itofix (arenaX);
      posY = itofix (temp - arenaY);
    }
  else if (temp < arenaX * 2 + arenaY)
    {
      posX = itofix (temp - arenaX - arenaY);
      posY = itofix (arenaY);
    }
  else
    {
      posX = itofix (0);
      posY = itofix (temp - arenaX - arenaY - arenaX);
    }
}

loader :: ~loader ()
{

}
#endif
