#ifndef _LOADER_H_
#define _LOADER_H_

#include "allegro.h"

#include "unit.h"
#include "unitList.h"

#include <vector>
using namespace std;

/*
  The loader class does three things:
  1) creates the graphics and hitbox for a unit via createUnit.
  2) loads the units in a stage via loadStage
  3) instantiates the units, based on their unitCreate parameters in loadUnit.
 */

class arena;

class loader {

public:

  //constructor
  loader ();

  //destructor
  ~loader ();

  void init (unitList * units, DATAFILE * picData);
  void createUnit (int unitType, unitList * units, DATAFILE * picData);
  void loadUnit  (int unitType, unit * & un);
  void loadRound (int, int &, unitList *, BITMAP * &, dataObj *, DATAFILE *, bool);
  int getAffiliationByUnit (int);
  void randomlyPlaceUnit (arena *, fixed &, fixed &);
};

#endif
