#include <stdio.h>
#include <math.h>

#include "allegro.h"
#include "dataObj.h"
#include "battleMain.h"

#include <fstream>
#include <iostream>

#include <vector>
using namespace std;

#ifndef M_PI
   #define M_PI   3.14159
#endif

/* convert radians to degrees */
#define DEG(n)    ((n) * 180.0 / M_PI)

battleMain * bM;
dataObj * dO;

///////////////////
//   PROTOTYPES   //
////////////////////

int mainInitialize ();

/////////////////////

int mainInitialize ()
{
  int gfxmode = GFX_AUTODETECT_WINDOWED;

  bM = new battleMain ();
  dO = new dataObj ();
  
  //read variables from config file here
  dO -> readConfig ();

  if (dO -> getVideoSettings () -> getWindowed ())
    gfxmode = GFX_AUTODETECT_WINDOWED;
  else
    gfxmode = GFX_AUTODETECT_FULLSCREEN;

  set_color_depth (dO -> getVideoSettings () -> getColorDepth ());
  if (set_gfx_mode(gfxmode, dO -> getVideoSettings () -> getResolutionX (), dO -> getVideoSettings () -> getResolutionY (), 0, 0) != 0) {
    if (set_gfx_mode(GFX_SAFE, 640, 480, 0, 0) != 0) {
      set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
      allegro_message("Unable to set any graphic mode\n%s\n", allegro_error);
      return 1;
    }
  }

  bM -> setDataObj (dO);
  return (bM -> init ());
}

int main(void)
{
  int rezX = 640, rezY = 480;

  fstream configFile;

   if (allegro_init() != 0)
      return 1;
   install_keyboard();
   install_timer();
   install_mouse();

   //read config file; get size defaults
   configFile.open ("tasmConfig.txt", ios::in);

   if (configFile.is_open ())
     {
       configFile >> rezX;
       configFile >> rezY;
     }

   configFile.close ();

   /*
   set_color_depth (8);
   if (set_gfx_mode(GFX_AUTODETECT_WINDOWED, 640, 480, 0, 0) != 0) {
      if (set_gfx_mode(GFX_SAFE, 640, 480, 0, 0) != 0) {
	 set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
	 allegro_message("Unable to set any graphic mode\n%s\n", allegro_error);
	 return 1;
      }
   }
   */

   if (mainInitialize () == 0)
   {
     while (!key[KEY_ESC] ) { ///replace with generalized situation

       bM -> go ();

       //draw the buffer to the screen
       vsync();
       blit(bM -> getBuffer (), screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
     }
   }
   return 0;
}

END_OF_MAIN();
