#ifndef _POLEONUNIT_CPP
#define _POLEONUNIT_CPP_

#include "allegro.h"
#include "dataObj.h"
#include "unit.h"
#include "unitList.h"
#include "unitCreate.h"
#include "inputObj.h"
#include "cursor.h"
#include "gameConstants.h"
#include "tasmMath.h"
#include "playerUnit.h"

#include "poleonUnit.h"

#include <vector>
using namespace std;

poleonUnit :: poleonUnit ()
{

}

void poleonUnit :: init (int param1, int param2, int param3)
{
  costOfAttack1 = 0;
  costOfAttack2 = 200;
  costOfAttack3 = 1500;

  setHP (1000);
  setMaxHP (3000);

  moveSpeed = itofix (15);
  setAffiliation (affiliationPlayer);
}

void poleonUnit :: processInput (dataObj * dO, unitList * units)
{
  inputObj * iO = dO -> getInputObj ();
  fixed unitCursorAngle = itofix (0);
  vector <bool> * kwh = NULL;
  vector <bool> * kwc = NULL;
  vector <bool> * mwc = NULL;
  vector <bool> * mwh = NULL;
  unitCreate * uC = NULL;
  unit * pA = NULL;

  moveMag = 0;

  //create the player aim, if not created already.
  if ((units -> search (units -> getUnits (), searchByUnitType, unitPlayerAim)) -> size () <= 0)
    {
      	  uC = new unitCreate ();
	  uC -> unitType = unitPlayerAim;
	  uC -> posX = posX;
	  uC -> posY = posY;
	  uC -> faceAngle = drawAngle;
	  uC -> timeToCreate = 0;
	  uC -> ownerID = unitID;

	  units -> addCreate (uC);
    }

  if (currentActivity == charStatusDead || currentActivity == charStatusStun)
    return;

  //look at the player aim
  if ((units -> search (units -> getUnits (), searchByUnitType, unitPlayerAim)) -> size () > 0)
    {
      pA = units -> search (units -> getUnits (), searchByUnitType, unitPlayerAim) -> at (0);
      unitCursorAngle = pA -> getDrawAngle ();
    }

  if (cantMoveTime <= 0)
    drawAngle = unitCursorAngle;

  //////////////////////////////////////////

  //Done with aiming, now with walking.
  //affect the aim, as well.

  kwh = iO -> getKeyWasHit ();
  kwc = iO -> getKeyWasClicked ();

  if (cantMoveTime <= 0)
    {
      if (kwh -> at (keyUp))
	{
	  moveAngle = itofix (0);
	  moveMag = 4;
	}
      if (kwh -> at (keyDown))
	{
	  moveAngle = itofix (128);
	  moveMag = 4;
	}
      if (kwh -> at (keyLeft))
	{
	  if (kwh -> at (keyUp))
	    moveAngle = itofix (224);
	  else if (kwh -> at (keyDown))
	    moveAngle = itofix (160);
	  else
	    moveAngle = itofix (192);
	  moveMag = 4;
	}
      if (kwh -> at (keyRight))
	{
	  if (kwh -> at (keyUp))
	    moveAngle = itofix (32);
	  else if (kwh -> at (keyDown))
	    moveAngle = itofix (96);
	  else
	    moveAngle = itofix (64);
	  moveMag = 4;
	}
    }
  
  //to detect attacks...check the mouse click!
  mwc = iO -> getMouseWasClicked (); //click = press and release of key
  mwh = iO -> getMouseWasHit (); //hit = press (no release.) Useful for auto-fire attacks.

  //use powers of 2 so you can use bit masks to check it.

  if (cantAttackTime1 <= 0 && cantAttackTime2 <= 0 && cantAttackTime3 <= 0)
    pendingAttack = 0;

  if (cantAttackTime1 <= 0)
    {
      if (mwh -> at (0))
	{
	  pendingAttack += 1;
	}
    }

  if (cantAttackTime2 <= 0)
    {
      if (mwc -> at (1))
	{
	  pendingAttack += 2;
	}
    }

  if (cantAttackTime3 <= 0)
    {
      if (kwc -> at (keyDefense))
	{
	  pendingAttack += 4;
	}
    }
}

void poleonUnit :: addAttacks (dataObj * dO, unitList * units, int attack)
{
  unitCreate * uC = new unitCreate ();
  //vector <unit
  int numPC = (units -> search (units -> getUnits (), searchByUnitType, unitPoleonCircle)) -> size ();

  if ((attack & 1) > 0)
    {
      if (hitPoints > costOfAttack1)
	{
	  hitPoints -= costOfAttack1;

	  uC = new unitCreate ();
	  uC -> unitType = unitPoleonShot;
	  uC -> posX = posX;
	  uC -> posY = posY;
	  uC -> faceAngle = drawAngle;
	  uC -> timeToCreate = 0;
	  uC -> ownerID = unitID;
	  currentAttack = 1;
      
	  cantAttackTime1 += 5;

	  units -> addCreate (uC);
	}
    }
  
  if ((attack & 2) > 0)
    {
      
      for (int i = 0; i < 3 - numPC; i++)
	{
	  if (hitPoints > costOfAttack2)
	    {
	      hitPoints -= costOfAttack2;
	      
	      cantAttackTime2 += 5;
	      cantAttackTime1 += 5;	      

	      uC = new unitCreate ();
	      uC -> unitType = unitPoleonCircle;
	      uC -> posX = posX;
	      uC -> posY = posY;
	      uC -> faceAngle = drawAngle;
	      uC -> timeToCreate = 0;
	      uC -> ownerID = unitID;
	      uC -> param1 = numPC;
	      currentAttack = 2;
	      units -> addCreate (uC);

	    }
	}
    }
  
  if ((attack & 4) > 0)
    {
      if (hitPoints > costOfAttack3)
	{
	  hitPoints -= costOfAttack3;
	  
	  cantAttackTime1 += 30;
	  cantAttackTime2 += 30;
	  cantAttackTime3 += 30;
	  cantMoveTime += 30;
	  
	  uC = new unitCreate ();
	  uC -> unitType = unitPolosion;
	  uC -> posX = posX;
	  uC -> posY = posY;
	  uC -> faceAngle = itofix (0);
	  uC -> timeToCreate = 0;
	  uC -> ownerID = unitID;
	  currentAttack = 4;
	  units -> addCreate (uC);
	}
    }
}

int poleonUnit :: getHPBarColor ()
{
  //this tells battlemain what color it should be using for the health bar.
  float ratiohp = 0.0;

  if (getMaxHP () > 0)
    ratiohp = (1.0 * getHP ()) / (1.0 * getMaxHP ());

  if (getHP () < (costOfAttack2 * 3))
    return makecol (125, 36, 36); //red
  else if (getHP () < costOfAttack3)
    return makecol (86, 71, 154); //blue
  else if (ratiohp < 1.0)
    return makecol (82, 179, 107); //green    
  else
    return makecol (204, 187, 46); //gold
  return 0;
}

poleonUnit :: ~poleonUnit ()
{

}
#endif
