#ifndef _UNITGRAPHICS_CPP_
#define _UNITGRAPHICS_CPP_

#include "unitGraphics.h"

#include "allegro.h"
#include "gameConstants.h"

#include <vector>
using namespace std;

unitGraphics :: unitGraphics ()
{
  vecPics = new vector <vector <BITMAP *> *> (charAnimNum);

  vector <vector <BITMAP *> *>::iterator the_iterator;
  the_iterator = vecPics -> begin();
  while(the_iterator < vecPics -> end()) {
      (*the_iterator) = new vector <BITMAP *> (0);
      the_iterator++;
  }
  vecPicsInit = new vector <bool> (charAnimNum, false);
  picSize = 0;
  
  unitType = unitNull;
}

int unitGraphics :: insertPic (BITMAP * pic, int animIndex)
{
  //inserts picture at the end of the animation (assumes array is full)
  if (animIndex < int (vecPics -> size ()))
    {
      vecPics -> at (animIndex) -> resize (vecPics -> at (animIndex) -> size () + 1);
      vecPics -> at (animIndex) -> at (vecPics -> at (animIndex) -> size () - 1) = pic;
      if (animIndex == 0)
	picSize = pic -> w;
      return 0;
    }
  else
    return -1;
}

BITMAP * unitGraphics :: getPic (int animIndex, int frameIndex)
{
  if (animIndex >= int (vecPics -> size ()))
    return NULL;

  if (frameIndex >= int (vecPics -> at (animIndex) -> size ()))
    return NULL;

  return vecPics -> at (animIndex) -> at (frameIndex);
}

int unitGraphics :: getSizeOfVector (int animIndex)
{
  if (animIndex >= int (vecPics -> size ()))
    return -1;

  return vecPics -> at (animIndex) -> size();
}

int unitGraphics :: getPicSize ()
{
  return picSize;
}

unitGraphics :: ~unitGraphics ()
{

}
#endif
