#ifndef _UNITLIST_H_
#define _UNITLIST_H_

#include "allegro.h"
#include "loader.h"

#include <vector>
using namespace std;

class unit;
class unitCreate;
class unitGraphics;
class hitbox;

/*
  unitList handles the creation and destruction of units, hitboxes, and unitCreates.
 */

class unitList {

public:

  //constructor
  unitList ();

  void clearAll ();

  void addUnit (unit *);
  unit * getUnit (int);
  vector <unit *> * getUnits ();
  unit * at (int);

  void addCreate (unitCreate *);
  void addGraphics (unitGraphics *);
  void addHitbox (hitbox *);

  vector <unit *> * search (vector <unit *> *, int criterion, int spec1);
  int searchHitBox (int spec1);
  int searchGraphics (int spec1);

  void createUnits ();
  void cullUnits ();

  void setLoader (loader *);

  bool anyRemainingAffiliation (int);
  int latestTime ();

  //destructor
  ~unitList ();

protected:
  vector <unit *> * units;
  int unitIDCount;

  vector <unitCreate *> * uCQ;
  vector <unitGraphics *> * uGQ;
  vector <hitbox *> * hbQ;
  loader * lder;
};

#endif
