#ifndef _VIDEOSETTINGS_H_
#define _VIDEOSETTINGS_H_

#include <stdio.h>
#include <math.h>

#include "allegro.h"

#include <vector>
using namespace std;

class videoSettings
{
public:
  videoSettings ();
  ~videoSettings ();

  //   general video settings
public:
  void getCamera (int &, int &);
  void setCamera (int, int);
  void getResolution (int &, int &);
  int getResolutionX ();
  int getResolutionY ();
  void setResolution (int , int);
  void getBackgroundColor (int &, int &, int &);
  void setBackgroundColor (int, int, int);

  void setObjectPositions (int, int);

  int getArenaPosX ();
  int getArenaPosY ();
  fixed getArenaScale ();

  int getHPBarStartX ();
  int getHPBarStartY ();
  int getHPBarSizeX ();
  int getHPBarSizeY ();

  bool getWindowed ();
  void setWindowed (bool);

  int getColorDepth ();
  void setColorDepth (int);

protected:
  int cameraX, cameraY;
  int resolutionX, resolutionY;
  int backgroundR, backgroundG, backgroundB;
  bool windowed;
  int colorDepth;

  int arenaPosX, arenaPosY;
  fixed arenaScale;

  int hpStartX, hpStartY;
  int hpSizeX, hpSizeY;
};

#endif
